if(!dojo._hasResource["com.ibm.customize.AddContentController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.AddContentController"] = true;
 // This is a controller that customizes the content on a page

dojo.provide("com.ibm.customize.AddContentController");

dojo.require("com.ibm.portal.data.InstalledPortletStore");
dojo.require("com.ibm.data.JsonStore");
dojo.require("com.ibm.portal.fx.Transitions");
dojo.require("dojo.string");
dojo.require("dojo.i18n");
dojo.require("dojo.DeferredList");
dojo.requireLocalization("com.ibm.bundles", "Shelf");

com.ibm.customize.AddContentController = {
	controlClass: "ibmPortalControlContainer",		// the css class name on dnd portlet controls
	mainContainerClass: "ibmPortalMainContainer",	// the css class name on the dom node for containers[0]

/***********************************************/
/*       Customize Controller API			   */
/***********************************************/

	store: null,		// the data store providing APIs to manipulate content
	item: null,			// the data store item representing the current page
	pageId: "", 		// the id of the current page
	parent: null,		// a pointer to this controller's parent, if one exists
	dirty: false,		// true if there are changes pending
	started: false,		// true if the widget is started up
	refresh: true,		// true if a page refresh is required to show saved changes

// if this controller is to be standalone and maintain compliance with the Customize Controller API, it must be supplied with a startup function

	makeDirty: function(/*bool*/change){
		// summary: changes the dirty attribute
		// change: value to assign to the dirty attribute
		this.dirty = change;
	},

	processChange: function(/*Object*/args){
		// summary: used as an event handler for when a user clicks on a result
		// args: 	id: the unique id of the piece of content
		//			label: the display name of the piece of content
		//			prefsMapFcn (optional): a function or the name of a function in dot notation which retrieves a map of the preferences for the piece of content
		//			map (optional): an object of parameters to be passed to prefsMapFcn
		//			takeoverFcn (optional): a function or the name of a function in dot notation which will be run instead of the body of this submit function
		//			takeoverObject (optional): an object of parameters to be passed to takeoverFcn
		if (!this.dirty) {
			this.makeDirty(true);
		}
		if(args.takeoverFcn) {
			args.takeoverObject = dojo.mixin(args.takeoverObject, {controller: this});
			if (dojo.isString(args.takeoverFcn)) {
				return dojo.getObject(args.takeoverFcn)(args.takeoverObject);
			} else {
				return args.takeoverFcn(args.takeoverObject);
			}
		}
		if(!this.parent) {
			setTimeout(function(){this.beforeSubmit().addCallback(dojo.hitch(this, function(){this.submit(args);}));}, 1);
		}
		return this.apply(args);
	},

	apply: function(/*Object*/args){
		// get the container id off of the DOM div
		var container = this._getFirstContainer();
		
		// get the container id
		var containerID = null;
		var pageIdSuffix = "@oid:" + this.pageId;
		if (container) {
			containerID = "lm:" + container.id + pageIdSuffix;
		} else {
			return;
		}
		
		// get next sibling
		var nextSibling = null;
		var nextDomSibling = null;
		var controlid = null;
		if(com.ibm.portal.dnd.PORTLET_MEDIATOR.fromShelf){
			var dndSibling = dojo.byId(com.ibm.portal.dnd.PORTLET_MEDIATOR.currentTargetId);
			if (dndSibling) { 
				controlid = dndSibling.getAttribute("controlid"); nextDomSibling = dndSibling; 
			}
			if (controlid && controlid.length > 0 && controlid != "null") {
				nextSibling = controlid + pageIdSuffix;
			} 
			com.ibm.portal.dnd.PORTLET_MEDIATOR.resetTargets();
		} else {
			var portlets = dojo.query("." + this.controlClass,container);
			for (var i = 0; i < portlets.length; i++){
				controlid = portlets[i].getAttribute("controlid");
				if (controlid && controlid.length > 0 && controlid != "null") {
					nextSibling = controlid + pageIdSuffix; 
					nextDomSibling = portlets[i];
					break;
				}
			}
		}
		com.ibm.portal.dnd.PORTLET_MEDIATOR.fromShelf = false;
				
		// create placeholder
		var placeholderDiv = dojo.create("div");
		container.insertBefore(placeholderDiv, nextDomSibling);
		var placeholder = new com.ibm.customize.placeholder({titleText:args.label,imagePath:this.imagePath,containerId:container.id},placeholderDiv);		
						
		// args for creating a new item in the Portal feed
		var modelArgs = {
			portletDefinitionId:args.id,
			parentId:containerID,
			pocType: "lm",
			type: "control"
		};
		
		if (nextSibling) {
			modelArgs.nextId = "lm:" + nextSibling;
		}
		
		var portletControl = this.store.newItem(modelArgs);
		var cid = this.store.getIdentity(portletControl);
		this.pendingItems[cid] = {item: portletControl, prefsMap: this._getPrefsMap(args), afterSubmitDfd: new dojo.Deferred(), placeholder: placeholder};
		
		this.addAfterSubmit(this.pendingItems[cid].afterSubmitDfd);
		
		var listener = dojo.connect(this.store, "onSaveComplete", this, function(saveList){
			if(saveList.hasItem(portletControl)) {
				dojo.disconnect(listener);
				listener = null;
				this._finalizeControl(portletControl, saveList);
				portletControl = null;
			}
		});
		
		var controlCId = cid.substring(3, cid.indexOf("@"));
		placeholder.finish(controlCId);
		return portletControl;
	},
	
	_finalizeControl: function(/*Item*/ portletControl, /*SaveList*/ saveList) {
		var cid = this.store.getCId(portletControl);
		var err = saveList.getError(portletControl);
		if(err) {
			var details = err.message;
			if (err.responseText.indexOf("EJPDB0124E") >= 0) {
				details = this.nlsBundle.add_content_missingRendererError;
			}
			this.pendingItems[cid].placeholder.error(this.nlsBundle.add_content_addContentError,details);
			delete this.pendingItems[cid];
		}
		else {
			if(this.pendingItems[cid].prefsMap) {
				this._setPreferences(portletControl, this.pendingItems[cid].prefsMap).addCallbacks(
					dojo.hitch(this, function(prefsItem){
						this._addIdToPlaceholder(portletControl);
						this.pendingItems[cid].afterSubmitDfd.callback();
						delete this.pendingItems[cid];
					}),
					dojo.hitch(this, function(error){
						var details = err.message;
						if(err.responseText.indexOf("EJPDB0124E") >= 0) details = this.nlsBundle["add_content_missingRendererError"];
						this.pendingItems[cid].placeholder.error(this.nlsBundle["add_content_addContentError"],details);
						this.pendingItems[cid].afterSubmitDfd.errback(error);
						delete this.pendingItems[cid];
					})
				);
			}
			else {
				this._addIdToPlaceholder(portletControl);
				this.pendingItems[cid].afterSubmitDfd.callback();
				delete this.pendingItems[cid];
			}
		}
	},
	
	_addIdToPlaceholder: function(control) {
		var cid = this.store.getCId(control);
		var contentID = this.store.getIdentity(control);
		contentID = contentID.substring(3,contentID.indexOf('@'));
		this.pendingItems[cid].placeholder.attr("controlid", contentID);
	},
	
	_getPrefsMap: function(args) {
		// if there is a function to get portlet preferences, get them, or else the preferences map is null
		if(args.prefsMapFcn) {
			if (dojo.isString(args.prefsMapFcn)) {
				return dojo.getObject(args.prefsMapFcn)(args.map);
			}
			else {
				return args.prefsMapFcn(args.map);
			}
		}
		return null;
	},
	
	_setPreferences: function(/*Item*/ portletControl, /*Object*/ prefsMap) {
		// summary: Sets preferences on the portletControl item using the prefsMap for the
		//		map of preferences to set and the args to specify callbacks using onComplete,
		//		onError, and scope properties.
		// portletControl: Item in data store referring to the layout model control
		// prefsMap: Object map of preferences to set according to key-value pairs in map.
		// returns: Deferred object which is fired when the preferences are set and saved.
		var dfd = new dojo.Deferred();
		var windowChain = this.store.getValue(this.store.getValue(portletControl, "portlet"), "portletWindowChain");
		windowChain.addOnLoad(dojo.hitch(this, function(chain){
			var prefs = chain.getPreferences();
			for(var key in prefsMap) {
				var val = prefsMap[key];
				prefs[dojo.isArray(val) ? "setValues" : "setValue"](key, val);
			}
			var listener = dojo.connect(this.store, "onSaveComplete", this, function(saveList) {
				if(saveList.hasItem(prefs.item)) {
					dojo.disconnect(listener);
					var error = saveList.getError(prefs.item);
					if (error === null) {
						dfd.callback(prefs.item);
					} else {
						dfd.errback(error);
					}
					dfd = null;
					windowChain = null;
					prefs = null;
				}
			});
			
			prefs.store();
		}));
		return dfd;
	},

	undo: function(/*Object*/args){
		for(var cid in this.pendingItems) {
			this.store.revertItem(this.pendingItems[cid].item);
			this.pendingItems[cid].placeholder.destroyRecursive();
			delete this.pendingItems[cid];
		}
		dojo.forEach(this.beforeSubmitDfds, function(dfd){dfd.cancel();});
		this.beforeSubmitDfds = [];
		this.afterSubmitDfds = [];
	},
	
	undoItem: function(/*Item*/ portletControl) {
		var cid = this.store.getCId(portletControl);
		this.store.revertItem(portletControl);
		this.pendingItems[cid].afterSubmitDfd.callback();
		delete this.pendingItems[cid];
	},

	beforeSubmit: function(/*Object*/args){
		// summary: Returns a Deferred object which is fired when this controller is ready
		//		to be submitted.  Fires all the Deferreds in the list of beforeSubmit dfds
		//		that were added using the addBeforeSubmit function.  When all of them callback
		//		the Deferred that this returns calls back as well.
		var dfd = (new dojo.Deferred()).addCallback(dojo.hitch(this, function(){
			var dfdl = new dojo.DeferredList(this.beforeSubmitDfds, false, false);
			dojo.forEach(this.beforeSubmitDfds, function(df){
				if(df.fired < 0) {
					df.callback();
				}
			});
			this.beforeSubmitDfds = [];
			return dfdl;	// chain up another deferred after dfd calls back so subsequent callbacks now wait on dfdl
		}));
		
		if (args && args.onError) {
			dfd.addErrback(args.onError);
		}
		
		var cbk = dojo.hitch(this, function(){
			dfd.callback();
		});
		if (!this.store.isItemLoaded(this.item)) {
			this.store.loadItem({
				item: this.item,
				onItem: cbk,
				onError: args ? args.onError : null
			});
		} else {
			cbk();
		}
		
		return dfd;
	},

	submit: function(/*Object*/args){
		// summary: saves any pending changes to the server.  This should only be called in a callback
		//		on the Deferred object returned by this controller's beforeSubmit function.
		// args: may contain an onComplete handler
		if (this.dirty) {
			this.makeDirty(false);
		}
		var finisher = function(res) {
			var dfd = this.afterSubmit();
			if (args.onComplete) {
				dfd.addCallback(dojo.hitch(args.scope, args.onComplete));
			}
			if (args.onError) {
				dfd.addErrback(dojo.hitch(args.scope, args.onError));
			}
		};
		this.store.save({onComplete: finisher, onError: finisher, scope: this});
	},
	
	afterSubmit: function() {
		var dfd = new dojo.DeferredList(this.afterSubmitDfds, false, false);
		this.afterSubmitDfds = [];
		return dfd;
	},
	
	addAfterSubmit: function(/*Deferred*/ dfd) {
		// summary: Adds a Deferred object to the list of deferreds that must all be fired before
		//		the submit process fires the onComplete handler.  These are NOT fired by the controller
		// 		themselves, but are simply used to attach callbacks to.  They are assumed to have been
		// 		fired at some point by whatever code added them to the afterSubmit queue. 
		if (dfd) {
			this.afterSubmitDfds.push(dfd);
		}
	},
	
	addBeforeSubmit: function(/*Deferred*/ dfd) {
		// summary: Adds a Deferred object to the list of deferreds that must all be fired before
		//		the Deferred object returned by beforeSubmit is fired. 
		if (dfd) {
			this.beforeSubmitDfds.push(dfd);
		}
	},
		
/***********************************************/
/*              Helper functions   	     	   */
/***********************************************/	
		
	_getFirstContainer: function(){
		if(com.ibm.portal.dnd.PORTLET_MEDIATOR.fromShelf){
			var container = dojo.byId(com.ibm.portal.dnd.PORTLET_MEDIATOR.currentParentId);
			return container;
		}
		// summary: returns a DOM node which is where the contents of layout container 0 are rendered
		var firsts = dojo.query("." + this.mainContainerClass); // length should be exactly 1
		if (firsts.length > 0 && dojo.hasClass(firsts[0], "dojoDndTarget")) {
			return firsts[0];
		}
		var containers = dojo.query(".ibmPortalLayoutContainer");
		for(var i = 0; i < containers.length; i++){
			if (dojo.hasClass(containers[i], "dojoDndTarget")) {
				return containers[i];
			}
		}
		// error, there is nowhere to add the new portlet
		var msg = this.nlsBundle.add_content_addContentError;
		var statusMessage = new com.ibm.widgets.StatusMessage("error", msg, "");
		dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmPortalStatusBox'}]);
	},
		
/**********************************************************/
/*       Functions to create "new" pieces of content      */
/**********************************************************/	
		
	newFeed: function(/*object*/args){ 
	    // summary: creates a new Feedspace portlet with user provided feed url
		// args: contains one item, getInfo, which is a function that takes the form data and runs a callback function on the validated user inputs
		var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
		var form = [{label:bundle.new_feed_title,id:"new_feed_title",value:"",regex:/\S+/,error:bundle.new_feed_enterTitle},{label:bundle.new_feed_url,id:"new_feed_url",value:"http://",regex:/http:\/\/\S+/,error:bundle.new_feed_enterUrl,ltr:true}];
		var submit = function(inputs){ args.submit({id:ibmPortalConfig.contentRenderers.feed,label:inputs.new_feed_title,prefsMapFcn:com.ibm.customize.AddContentController.getFeedspacePreferences,map:{url:inputs.new_feed_url,label:inputs.new_feed_title}}); };
		args.getInfo(form,bundle.new_feed_addFeed,bundle.add_content_add,null,submit);
	},
		
	newWCM: function(/*object*/args){ 
	    // summary: creates a new WCM item like a blog, wiki or solo blog
		// args: an associative array that contains:	getInfo: function that takes the form data and runs a callback function on the validated user inputs
		//												showInfo: function that takes an HTML payload and displays it to the user, then runs a callback function
		//												label (optional): a human readable label for the WCM item, such as "Wiki"
		//												type (optional): the type of WCM content, such as "WIKI_LIBRARY_TYPE"
		//												hub (optional): a datastore
		//												item (optional): an item in the datastore
		// args MUST contain EITHER label, type OR hub and an item containing the "label", and "type" attributes
		var label = args.label ? args.label : args.hub.getValue(args.item,"label","");
		label = (args.hub && args.hub.nlsBundle && args.hub.nlsBundle[label]) ? args.hub.nlsBundle[label] : label;
		var waitingMsg = args.hub.getValue(args.item,"waitingMsg","");
		waitingMsg = (args.hub && args.hub.nlsBundle && args.hub.nlsBundle[waitingMsg]) ? args.hub.nlsBundle[waitingMsg] : waitingMsg;
		var type = args.type ? args.type : args.hub.getValue(args.item,"type","");
		var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
		var genericAddStr = dojo.string.substitute(bundle.new_generic_add, [label]);
		var processInputs = dojo.hitch(args.controller, function(inputs){ 
			// context "this" object points to controller, args.controller 
			var name = dojo.string.trim(inputs.new_wcm_name);
			if(name && name.length > 0){
				var contr = com.ibm.customize.AddContentController;
				var closeOverlay = args.showInfo(waitingMsg);
				var validateNameCallback = dojo.hitch(this, function(response){
					if(response == "false"){ 
						closeOverlay();
						// set up the portlet to get created now
						var portletControl = args.submit({id:ibmPortalConfig.contentRenderers.wcm,label:name});
						// create the library before saving the portlet and then set up preferences on the
						// portlet based on the library id
						var createLibraryCallback = dojo.hitch(this, function(response){
							this.pendingItems[this.store.getCId(portletControl)].prefsMap = this._getPrefsMap({prefsMapFcn:contr.getJSRWcmRenderingPreferences,map:{contextid:response,title:name}});
						});
						// remove the portlet before saving if the library creation failed
						var createLibraryErrback = dojo.hitch(this, this.undoItem, portletControl);
						var beforeSubmitDfd = (new dojo.Deferred()).addCallback(dojo.hitch(this, "_processCreateLibrary", name, type, createLibraryCallback, createLibraryErrback, this.store, this.item));
						this.addBeforeSubmit(beforeSubmitDfd);
					} else {
						// alert the user that the name is already in use
						closeOverlay();
						args.getInfo(form,genericAddStr,bundle.add_content_add,bundle.new_wcm_wcmNameTaken,processInputs);
					}
				});
				contr._validateNameField(name, type, validateNameCallback, closeOverlay);
			} else {
				// alert the user that the name is invalid
				args.getInfo(form,genericAddStr,bundle.add_content_add,bundle.new_wcm_wcmNameInvalid,processInputs);
			}
		});
		// get a name for the WCM object from the user
	    var form = [{label:bundle.new_wcm_name,id:"new_wcm_name",value:"",regex:/^[\s\S]/,error:bundle.new_wcm_wcmNameInvalid}];
		args.getInfo(form,genericAddStr,bundle.add_content_add,null,processInputs);
	},
		
/*******************************************************/
/*       functions to create portlet preferences   	   */
/*******************************************************/	
		
	getBlurbPreferences: function(/*Object*/itemMap){
		// summary: get blurb portlet preferences
	    var map = {}; 
	    map.view_jsp = itemMap.url; 
	    return map;
	},
    
	getFeedspacePreferences: function(/*Object*/itemMap){
		// summary: get feedspace portlet preferences
	    var url = itemMap.url.replace(/&/g,"&amp;"); 
		var label = itemMap.label.replace(/&/g,"&amp;");
		var map = {};          
		map.selection = "/0";            
	    var subscriptions = '<?xml version="1.0" encoding="utf-8"?><opml version="2.0"><head><title><![CDATA[My Subscription List]]></title><dateModified><![CDATA[' + Date() + ']]></dateModified></head><body><outline xml:id="Subscription_1';
	    subscriptions = subscriptions + '" text="' + label + '" type="rss" isComment="false" isBreakpoint="false" created="' + Date() + '" category="" title="' + label + '" xmlUrl="' + url + '" /></body></opml>';
	    map.subscriptions = subscriptions;
	    return map;
	},
        
 	getWcmRenderingPreferences: function(/*Object*/args){  
		// summary: get WCM rendering portlet preferences
		var map = {};
	                     
		map.WCM_CONTENT_CONTEXT = args.context;
	    map.WCM_CONTENT_CONTEXT_DIS = args.context;
	    map.WCM_CONTENT_CONTEXT_LIB = args.title;
	    map.WCM_CONTENT_TYPE = "CONTENT"; 
	    map.WCM_CONTENT_CONTEXT_TYPE = "com.aptrix.pluto.site.SiteArea"; 
	    map.WCM_LISTENS_TO = "WCM_LINKING_OTHER"; 
	    map.WCM_PORTLET_TITLE = args.title; 
	                        
	    return map;
	},


 	getJSRWcmRenderingPreferences: function(/*Object*/args){  
		// summary: get WCM rendering portlet preferences
		var map = {};
	
	    map.WCM_CONTENT_CONTEXT_IDR = args.contextid; 
	    map.WCM_BROADCASTS_TO = "WCM_LINKING_NONE";
	    map.WCM_CONTENT_TYPE = "CONTENT";
	    map.WCM_CONTENT_CONTEXT_TYPE = "sitearea";
	    map.WCM_LISTENS_TO = "WCM_LINKING_OTHER";
	    map.WCM_PORTLET_TITLE = args.title;
		map.WCM_PORTLET_TITLE_TYPE = "WCM_PORTLET_TITLE_TYPE_GENERAL";
	                        
	    return map;
	},
                    
	getFeedreaderPreferences: function(/*Object*/itemMap){  
		// summary: get feed reader portlet preferences
	    var map = {};
	                        
	    map.FeedReaderPortlet_feedURL = itemMap.url.replace(/&/g,"&amp");
	    map.FeedReaderPortlet_feedName = itemMap.label;
	    map.FeedReaderPortlet_feedActionPane = "false";
	            
	    return map;
	},

/*******************************************************/
/*       Helper functions for blogs/wikis  	           */
/*******************************************************/	

	_addResourceListFeed: function(/*string*/new_name, /*string*/wcmLibraryType, /*string*/operation_id, /*function*/callback, /*function*/ errorFcn, /*resolver*/store, /*page item*/ item){
		// summary: verifies the name or copies a library with the feed
		var baseUrl = ibmPortalConfig.contentHandlerURI;
		var feedUrl = baseUrl + "?uri=wcmbw:id:" + operation_id;
		var message = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf").new_wcm_wcmNotCopied;
		dojo.publish("/window/unload/addPending",[message]);
		var getResourceHandler = dojo.xhrPost( {
			url: feedUrl,
			content: {
				blogname: new_name,
				resourcetype: wcmLibraryType
			},
			handleAs: "json",
			preventCache: true,
			load: function(data){
				var finalCallback = dojo.hitch(this,function(){ dojo.publish("/window/unload/removePending",[message]); if(callback) callback(data.items[0]); });
				if (operation_id == "copylibrary" && ibmPortalConfig.hasEditorRoleOnContentNode && (!ibmPortalConfig.wcmPageMetadata.contentRoot || !ibmPortalConfig.wcmPageMetadata.sharingScope)) {
					try {
						var cbk = dojo.hitch(this, function(){
							if (!ibmPortalConfig.wcmPageMetadata.contentRoot) {
								store.setValue(item, "metadata[com.ibm.portal.wcm.contentroot]$", data.items[0]);
							}
							if (!ibmPortalConfig.wcmPageMetadata.sharingScope) {
								store.setValue(item, "metadata[param.sharing.scope]$", "ibm.wcm.0." + new Date().getTime());
							}
							store.saveItems([item], {
								onComplete: finalCallback,
								onError: finalCallback
							});
						});
						if (!store.isItemLoaded(item)) {
							store.loadItem({
								item: item,
								onItem: cbk
							});
						}
						else {
							cbk();
						}
					} 
					catch (e) {
						finalCallback();
					}
				} else {
					finalCallback();
				}
			},
			error: function(error,ioArgs){
				if(com.ibm.ajax.auth && (ioArgs.xhr.status==401 || ioArgs.xhr.status === 0 )) {
					window.onbeforeunload = null;
					ibm.portal.debug.text( "Basic auth 401 found, trigger reload");
					com.ibm.ajax.auth.authenticationHandler();
					return;
                		}
				var errorMessage = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf").add_content_addContentError;
				var statusMessage = new com.ibm.widgets.StatusMessage("error", errorMessage, error.message);
				dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmPortalStatusBox'}]);
				dojo.publish("/window/unload/removePending",[message]);
				if (errorFcn) {
					errorFcn();
				}
			}
		 });
		 return getResourceHandler;
	},

	_validateNameField: function(/*String*/newName, /*String*/wcmLibraryType, /*function*/callback, /*function*/ errorFcn){
		// summary: makes sure that a name is not already taken in WCM
		var rv = false;
		if (newName && newName.length > 0) {
			rv = true;
			// test if the name is already in use
			return com.ibm.customize.AddContentController._addResourceListFeed( newName, wcmLibraryType, "validinput", callback, errorFcn); 
		}
	},

	_processCreateLibrary: function(/*String*/name, /*String*/wcmLibraryType, /*function*/callback, /*function*/ errorFcn, /*resolver*/store, /*page item*/ item){
		// summary: creates a blog/wiki
		var newLibrId = null;
		// use the feed to perform the copy operation
		var templateName = "Wiki Template";
		if (wcmLibraryType == "BLOG_LIBRARY_TYPE") {
			templateName = "Blog Template";
		} else if (wcmLibraryType == "BLOG_SOLO_TYPE") {
			templateName = "Blog Solo Template";
		}    
		return com.ibm.customize.AddContentController._addResourceListFeed(name, templateName, "copylibrary", callback, errorFcn, store, item);
	}
}

dojo.provide("com.ibm.customize.placeholder");
dojo.declare("com.ibm.customize.placeholder",
	[dijit._Widget, dijit._Templated],
	{
		titleText: "",
		infoAlt: "",
		imagePath: ".",
		containerId: null,
		controlid: "",
		templateString: '<div dojoAttachPoint="focusNode">' +
							'<div class="ibmPortalControl lotusWidget2" dojoAttachPoint="innerDiv">' +
								'<div class="lotusui">' +
									'<h2>' +
										'<span class="lotusLeft" dojoAttachPoint="titleSpan">${titleText}</span>' +
									'</h2>' +
								'</div>' +
								'<div class="lotusWidgetBody">' +
									'<div class="lotusMessage lotusInfo" style="margin: 0pt;">' +
										'<img src="${imagePath}/iconInfo.gif" alt="${infoAlt}"/>' +
										'<span>${infoAlt}</span>' +
									'</div>' +
								'</div>' +
							'</div>' +
						'</div>',
		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			controlid: ""
		}),
						
		constructor: function(){
			var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.infoAlt = bundle.add_content_noPreview;
		},
		
		finish: function(id){
			this.attr("controlid",id);
			dojo.addClass(this.domNode,"ibmPortalControlContainer dojoDndItem");
			dojo.attr(this.domNode, "dndType", com.ibm.portal.dnd.PORTLET_MEDIATOR.type);
			this.innerDiv.id = id;
			dojo.addClass(this.titleSpan,"ibmPortalPortletTitle ibmPortalControlDndHandle dojoDndHandle");
			com.ibm.portal.dnd.PORTLET_MEDIATOR.dndContainers[this.containerId].sync();
		},
		
		error: function(msg,details){
			this.destroy(false);
			if(msg){
				var statusMessage = new com.ibm.widgets.StatusMessage("error", msg, details);
				dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmPortalStatusBox'}]);
			}
		}
	});

}
