if(!dojo._hasResource["com.ibm.mm.builder.dialog.ReorderingPageDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.ReorderingPageDialog"] = true;
dojo.provide("com.ibm.mm.builder.dialog.ReorderingPageDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Tree");
dojo.require("dijit.tree.TreeStoreModel");
dojo.require("dojo.fx");
dojo.require("dojo.string");
dojo.require("com.ibm.mm.builder.iwidget.navigation.NavigationStore");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");

/**
 * This class will initialize the embed page widget UI element.
 */
dojo.declare("com.ibm.mm.builder.dialog.ReorderingPageDialog", [dijit._Widget, dijit._Templated], {
    /**
     * the ID for the page to be reordered.
     * @type String
     */
	pageId:null,
	spaceId:null,
	
    widgetId:null,
	
	store: null,
	navigationTree: null,
    targetPageId: null,
	_lastSelection: null,          // last selected dom node
	
	// Attach points
	messageBox: null,
	navTree: null,
	pageTitleLabel: null,
	form: null,
	
	widgetsInTemplate : true,
	
	templateString: null,
	
    constructor: function(args){
        dojo.mixin(this,args);
        this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
        this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
        this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dialog.ReorderingPageDialog");
        
        this.templateString = "<div class='reorder-page-dialog'>\
          <form dojoAttachPoint='form' onsubmit='return false;'>\
            <div class='dialog-content'>\
              <div class='lotusMessage' role='alert' dojoAttachPoint='messageBox' style='display:none'></div>\
              <div class='page-position-buttons-area' role='region' aria-label='page position buttons'>\
                <fieldset>\
                  <legend class='title' dojoAttachPoint='pageTitleLabel'></legend>\
                  <ul class='buttons-list'>\
                    <li>\
                      <input id='" + this.widgetId + "above' type='radio' name='position' value='previous'>\
                      <label for='" + this.widgetId + "above' class='page-position-buttons'>${I_ABOVE_THE_SELECTED_PAGE}</label>\
                    </li>\
                    <li>\
                      <input id='" + this.widgetId + "below' type='radio' name='position' value='next'>\
                      <label for='" + this.widgetId + "below' class='page-position-buttons'>${I_BELOW_THE_SELECTED_PAGE}</label>\
                    </li>\
                    <li>\
                      <input id='" + this.widgetId + "children' type='radio' name='position' value='children' checked>\
                      <label for='" + this.widgetId + "children' class='page-position-buttons'>${I_AS_CHILD_OF_SELECTED_PAGE}</label>\
                    </li>\
                  </ul>\
                </fieldset>\
              </div>\
              <div class='nav-tree'>\
                <div dojoAttachPoint='navTree' role='region' aria-label='page tree'></div>\
              </div>\
            </div>\
            <div dojoType='com.ibm.mm.builder.dialog.DialogFooter' dojoAttachEvent='onSave: save, onCancel: hide'>\
            </div>\
          </form>\
        </div>";
    },
	
	postMixInProperties: function() {
		this.bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.messages = com.ibm.mm.builder.coreWidgetsMessages;
        dojo.mixin(this, this.bundle);
    },
	
	setPageId: function(pageId, spaceId) {
		this.pageId = pageId;
		this.spaceId = spaceId || this.spaceUtil.getSpaceIdByPageId(pageId);
		dojo.fadeOut({node: this.messageBox}).play();
	},
	
	refresh: function() {
		this.showMessage(false);
		this.targetPageId = null;

		this.currentPageId = this.pageId;
		var currentPageName = this.pageUtil.getPageTitle(this.currentPageId);

		// this.currentPageId = this.pageUtil.getCurrentPageId();
		// var currentPageName = this.pageUtil.getCurrentPageTitle();
		
		this.pageTitleLabel.innerHTML = this.bundle.I_MOVE_THE_PAGE_TO_BE;
        
        if (this.navigationTree) {
            this.navigationTree.destroy();
        }
        
		var navModel = this.navigationUtil.getNavigationModel();
		this.store = new com.ibm.mm.builder.model.NavigationStore(navModel, this.spaceId, this.pageId);
		var model = new dijit.tree.TreeStoreModel({
            store : this.store,
            labelAttr : "title",
            typeAttr : "type",
            childrenAttr: ["children"]
		});
		
		this.navigationTree = new dijit.Tree({
            id: "navigation_tree_" + this.widgetId,
			model: model,
            persist : false,
			showRoot : true,
			getIconClass : function(/*dojo.data.Item*/ item, /*Boolean*/ opened) {
                return (!item || item === this.model.store.rootNode) ? "rootNode" : "pageNode";
            }
        }).placeAt(this.navTree);
		
		// #10147: remove the blue pane on the root node of the tree view.
        if (!dojo.isIE) {
            dojo.query(".dijitTreeIsRoot .dijitTreeRow .dijitTreeLabel", this.navTree).at(0).style({
                backgroundColor: "inherit"
            });
        }
		
		this.navigationTree.startup();
        this.connect(this.navigationTree, "onClick", "onTitleClick");
		
		// #13126
		this.connect(this.navigationTree, "_expandNode", "onExpandNode");
	},
	
	/**
	 * #13126
	 * Reset DijitTeeNode width in case the background position exceed the width when the node is being expanded.
	 */
    onExpandNode: function(node) {
        // 20490: PORTAL: highlights not working properly on move pg. dialog
        // not setting 'width' style to have the highlight cover the whole tree
		// view
        // var pixels = (Math.max(node.indent + 5, 0) * 19) + "px";
        // dojo.style(node.domNode, "width", pixels);
    },
	
	onTitleClick: function(item, node) {
		var domNode = node.contentNode;
		if (domNode !== this._lastSelection) {
			if (this._lastSelection) {
				dojo.removeClass(this._lastSelection, "selected");
			}
            dojo.addClass(domNode, "selected");
            this._lastSelection = domNode;
		}
		
		var inputNode = dojo.query("input[name='position']", this.form);
        inputNode.forEach(function(input) {input.disabled = false;});
		if (item === this.pageUtil.getPageNode(this.currentPageId)) {
			// Current node is not allowed
			this.showMessage(this.messages.E_DIFFERENT_LOCATION_REQUIRED_0, "error");
			inputNode.forEach(function(input){
				input.disabled = true;
			});
		} else  if (this.navigationUtil.isDescendant(this.currentPageId, item.getID())) {
			// Descendant node is not allowed
			this.showMessage(this.messages.E_NEW_PAGE_POSITION_MISSING_0, "error");
			inputNode.forEach(function(input){
				input.disabled = true;
			});
		} else {
			var currentPage = this.pageUtil.getPageNode(this.currentPageId);
			var invalidMove=this._getInvalidMoveMethod(item,currentPage);
			
			if(!!invalidMove && invalidMove.length>0){
				if(invalidMove.length<3){
					this.showMessage(false);
				}else{
					this.showMessage(this.messages.E_DIFFERENT_LOCATION_REQUIRED_0, "error");
				}
				
				this._disableInputs(inputNode,invalidMove);
			}
			
			if (!dojo.every(inputNode, function(input){
				return input.disabled;
			})) {//skip this check when all the inputs are already disabled
				inputNode.forEach(function(input){
					if (!input.disabled) {
						var position = input.value;
						var context = this.navigationUtil.getReorderPageContext(item.getID(), position);
						// @Stephan #11481 Start
						// input.disabled =
						// !this.navigationUtil.getNavigationModel().confirmInsert(null,
						// context.parent, null); // FIXME: comment out this
						// line
						input.disabled = !this.navigationUtil.getNavigationModel().confirmInsert(currentPage, context.parent, context.next);
					// @Stephan #11481 End
					}
				}, this);
				if (dojo.every(inputNode, function(input){
					return input.disabled;
				})) {
					this.showMessage(this.messages.E_MOVE_PAGE_INSUFFICIENT_ACCESS_RIGHTS_0, "error");
				}
				else {
					this.showMessage(false);
				}
			}
		}
        this.targetPageId = item.getID();
	},
	
	_getInvalidMoveMethod:function(item,page){
		if (item === this.store.rootNode) {
                // Only position children is allowed for rootNode
				var invalidMove=["previous","next"];
				var pageContenxt = this.navigationUtil.getPageContext(page.getID());
				if(pageContenxt.parent == item){//if the page is already the direct child of root
					invalidMove.push("children");
				}
				return invalidMove;
        }else{
			var pageContext = this.navigationUtil.getPageContext(item.getID());
			var result=[];
			if(pageContext.next==page){
				result.push("next");
			}
			if(pageContext.previous ==page){
				result.push("previous");
			}
			if(this.navigationUtil.isDescendant(item.getID(),page.getID(),1)){
				result.push("children");
			}
			return result;		
		}
			

	},
	
	_disableInputs:function(inputNode,/*Array*/disableValues){
		if(!dojo.isArray(disableValues)){
			disableValues=[];// enable all
		}
		var changeSelection = false;
		inputNode.forEach(function(input){
			if (dojo.indexOf(disableValues,input.value)>=0) {
				if (input.disabled === false && input.checked === true){
					// uncheck disabled radio
					input.checked = false;
					changeSelection = true;
				}
				input.disabled = true;
			} else {
				input.disabled = false;
			}
		});
		// find a new valid selection: first enabled radio from top
		if (changeSelection === true) {
			var selectionFound = false;
			inputNode.forEach(function(input){
				if (input.disabled === false && !selectionFound){
					input.checked = true;
					selectionFound = true;
				}
			});
		}
	},
	
	
	hide: function() {
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.widgetId);
		if (this.store) {
			this.store.reset();
		}
	},
	
	save: function() {
		var position = dojo.formToObject(this.form).position;
		var currentPageParentId = this.pageUtil.getParentPageId(this.currentPageId);
		var targetPageParentId = this.pageUtil.getParentPageId(this.targetPageId);
		var currentPage = this.pageUtil.getPageNode(this.currentPageId);
		
		if (this.targetPageId && position) {
			var context = this.navigationUtil.getReorderPageContext(this.targetPageId, position);
			// @Stephan #11481 Start
			// Enable if..else below
			if (this.navigationUtil.getNavigationModel().confirmInsert(currentPage, context.parent, context.next)) {
				var result = this.navigationUtil.reorderPageNode(this.currentPageId, this.targetPageId, position);
				
				if (result) {
					this.showMessage(result, "error");
				}
				else {
					//update space manager UI
					var constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
					dojo.publish(constants.Topic.Space.refresh,[constants.Action.MOVE_PAGE, {currentPageId:this.currentPageId, currentPageParentId:currentPageParentId, targetPageId:this.targetPageId, targetPageParentId:targetPageParentId, position:position}]);
					this.hide();
				}
			}
			else {
				this.showMessage(this.messages.E_MOVE_PAGE_INSUFFICIENT_ACCESS_RIGHTS_0, "error");
			}			
			// @Stephan #11481 End
		} else {
			this.showMessage(this.messages.E_NEW_PAGE_POSITION_MISSING_0, "error");
			this.LOGGER.severe("save", this.messages.E_NEW_PAGE_POSITION_MISSING_0);
		}
	},
	
	/**
	 * Display message in message box
     * @param {Object} message
	 * @param {Object} type Optional. Type of message, includes 'info', 'error', 'warning'
	 */
	showMessage: function(message, type) {
		if (!message) {
            dojo.fadeOut({node: this.messageBox}).play();
            dojo.style(this.messageBox, "display", "none");
			return false;
		}
		
		dojo.empty(this.messageBox);
		var img = dojo.create("img", {}, this.messageBox);
		var span = dojo.create("span", {
			"innerHTML": message
		}, this.messageBox);
		
		switch(type) {
			case "info":
                dojo.attr(img, {
					"alt": "Information",
					"src": builderConfig.builderPath + "/images/info_icon.png" // JSLINT-IGNORE
				});
                dojo.toggleClass(this.messageBox, "lotusWarning", false);
                dojo.toggleClass(this.messageBox, "lotusInfo", true);
				break;
			case "warning":
			    dojo.attr(img, {
					"alt": "Warning",
					"src": builderConfig.builderPath + "/images/warning_icon.png"
				});
                dojo.toggleClass(this.messageBox, "lotusWarning", true);
                dojo.toggleClass(this.messageBox, "lotusInfo", false);
                break;
            default:       // "error" as default
                dojo.attr(img, {
					"alt": "Error",
					"src": builderConfig.builderPath + "/images/error_icon.png"
				});
                dojo.toggleClass(this.messageBox, "lotusWarning", false);
                dojo.toggleClass(this.messageBox, "lotusInfo", false);
		}
		dojo.style(this.messageBox, "display", "block");
        dojo.fadeIn({node: this.messageBox}).play();
	}
});

}
