if(!dojo._hasResource["com.ibm.mm.builder.iwidget.pagesource.PageSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.pagesource.PageSource"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author Erik (bizheng@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.pagesource.PageSource");

dojo.require("dijit._base.manager");
dojo.require("dijit.Editor");
dojo.require("dojox.data.dom");

dojo.declare("com.ibm.mm.builder.iwidget.pagesource.PageSource", null, {
	
    imgControl: null,
    
    layoutIds:null,
    
	codeEditor: null,
	
	constructor: function(params){
		this.codeEditor = params.codeEditor;
		this.layoutIds = params.layoutIds;
	},
	
	/**
     * This is the action method when user click "Go to source" in mode selector.
     * It will display the Page Source custom dialog, show the page source in source mode.
     */
    openSource: function(){
        this.getSource();
        this.setPageSourceMode("source");
        dijit.byId("pageSourceContainer").show();
        com.ibm.mm.builder.utils.htmlUtil.setUnderlayBgColor();
        dijit.byId("pageSourceContainer")._position = function(){};
        if (this.imgControl){ this.imgControl.onOutImage(); }
    },
    
    /**
     * This is the action method when user click "Edit Mode" button in Page Source source mode.
     * It will change the page source from source mode to edit mode.
     */
    editMode: function(){
        this.setPageSourceMode("edit");
        var realSource = this.getUnescapedSourceFromEditor();
        if (document.all) {
            //For IE7, we have to replace SPAN to span
            realSource = realSource.replace(/SPAN/g, "span").replace(/DIV/g, "div");
        }
        var sourceContent = realSource.replace(/(<span)(.*?)(>)/g, "&lt;span$2&gt;<br>").replace(/<\/span>/g, "&lt;/span&gt;<br>").replace(/(<div)(.*?)(>)/g, "&lt;div$2&gt;<br>").replace(/<\/div>/g, "&lt;/div&gt;<br>").replace(/(<a)/g,"&lt;a").replace(/<\/a>/g,"&lt;/a&gt;<br>");
        var pageSourceEdit = dijit.byId("pageSourceEdit");
        if (!pageSourceEdit) {
            var editNodeTmp = dojo.byId('pageEdit');
            editNodeTmp.style.fontSize = "13px";
            editNodeTmp.innerHTML = sourceContent;
            var editor = new dijit.Editor({id: "pageSourceEdit",height: '443px'}, editNodeTmp);
            editor.domNode.id = 'pageEdit';
        }else{
            pageSourceEdit.editNode.innerHTML = sourceContent;
        }
        this.setEditModeBgColor();
    },   
    
    /**
     * This is the action method when user click "Source Mode" button in Page Source edit mode.
     * It will change the page source from source mode to edit mode.
     */
    sourceMode: function(){
        this.setPageSourceMode("source");
        var content = dijit.byId("pageSourceEdit").getValue().replace(/<br.*?>/g, '\n');
		
		this.codeEditor.setCode(this.unescape(content));
    },
	
    /**
     * This is the action method when user click "Save" button in Page Source source mode and edit mode.
     * Argument passed in saveSource should indicate whether current Page Source is source mode or edit mode
     * It will save the content in Page Source to current page, and call navigation api to render current page again.
     */
    saveSource: function(){
        var mode = arguments[0];
        var saveContent;
        if (mode == "source") {
			// source mode, get source from real dom
            saveContent = this.getUnescapedSourceFromEditor();
        }else{
			// edit mode, get the editor's value directly
            var editor = dijit.byId("pageSourceEdit");
            saveContent = editor.getValue().replace(/<br.*?>/g, '');
            saveContent = this.unescape(saveContent);
        }
		try{
			this.saveToPage(saveContent);
		}catch(e) {
            return;
        }
        dojo.publish(com.ibm.mm.builder.eventTopics.Page_ContentChanged,[saveContent]);
		com.ibm.mashups.services.ServiceManager.getService("eventService").publishEvent("/enabler/pageChanged");
        dijit.byId("pageSourceContainer").hide();
    },	

    /**
     * This method is called by this.openSource().
     * It will get the source of current page and set it to the editor of source mode dialog of Page Source
     */
    getSource: function(){
        var data;
        try {
            data = this.getIWidgetsMarkup();
            data = data.replace(/SPAN/g, "span").replace(/(<span)([^>]*)(\/>)/g, "$1$2></span>").replace(/(<LINK)([^>]*)(\/>)/g, "").replace(/>/g, ">\n").replace(/<\//g, "\n</").replace(/(\n)(\n*)(\n)/g, "\n").replace(/\n\s*/g, "\n");
        } catch (e) {
            data = "no source for this page";
        }
		this.codeEditor.setCode(data);
    },
	    
	/**
     * This method will call navigation api to save the content into current page
     * @param content(stirng): the content to save into page
     */
    saveToPage: function(content){
		if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()){
			var pageContent = content || this.getIWidgetsMarkup() || "<div class='noPageContent'>" + 
					com.ibm.mm.builder.coreWidgetsStrings.W_NO_PAGE_TO_SHOW + 
				"</div>";
			com.ibm.mm.builder.utils.pageUtil.saveCurrentPage(pageContent);
		}
    },
	
	/**
	 * get unescaped source from editor
     * replace some tags in editor to get the real html source
     * @return formatted text in editor of view source
     */
    getUnescapedSourceFromEditor: function(){
        var realSource = frame.contentWindow.editor.innerHTML;
        realSource = this.unescape(realSource);
        realSource = realSource.replace(/<font.*?>/g, "").replace(/<\/font>/g, "").replace(/<br>/g, "");
        realSource = realSource.replace(/<FONT.*?>/g, "").replace(/<\/FONT>/g, "").replace(/<BR>/g, "").replace(/<SPAN>/g, "<span>").replace(/<DIV>/g, "<div>");
        return realSource;
    },
    
    /**
     * Parse the dom node of canvas and get the iwidget source code of page
     * @return the html content of current page
     */
    getIWidgetsMarkup: function(){	
		var source = "";
        var layouts = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().getLayouts();
		var i = 0;
		var getMarkupRecur = dojo.hitch(this, function(node, status){
			if (node) {
				// add more supported widget types here!
				var markupsFromTheLayout = this.getMarkups(
					node,
					[	
						com.ibm.mm.builder.constant.mmIWidget,
						com.ibm.mm.builder.constant.mmGGadget,
						com.ibm.mm.builder.constant.iwIWidget,
						com.ibm.mm.builder.constant.iwGGadget
					]
				);
				if (markupsFromTheLayout != ""){
					source = source + markupsFromTheLayout + "\n";
				}
			}
			if (i >= layouts.length) {
				return;
			}
			var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(layouts[i++]);
			var getMarkupDeferred = widgetWrapper.getMarkup();
			getMarkupDeferred.setFinishedCallback(getMarkupRecur);
			getMarkupDeferred.start();
		});
		getMarkupRecur();
		while(i < layouts.length){
			//wait until all the layouts are processed
		}
    	return source;
	},
	
	getMarkups:function(/*node*/parentNode,/*Array*/types){
		var source = "";
		for(var i=0;i<types.length;i++){
			dojo.query("." + types[i], parentNode).forEach(function(widget){
				try{
					var toDel;
					switch(types[i]){
						case com.ibm.mm.builder.constant.mmIWidget:
						    toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.iWidgetContent, widget);
							if (toDel.length > 0) {
						        widget.removeChild(toDel[0]);
						    }
						    toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.iWidgetLoading, widget);
						    if (toDel.length > 0) {
						        widget.removeChild(toDel[0]);
						    }
							break;
						case com.ibm.mm.builder.constant.iwIWidget:
						    toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.iwWidgetContent, widget);
							if (toDel.length > 0) {
						        widget.removeChild(toDel[0]);
						    }
						    toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.iwWidgetLoading, widget);
						    if (toDel.length > 0) {
						        widget.removeChild(toDel[0]);
						    }
							break;
						case com.ibm.mm.builder.constant.mmGGadget:
					   	 	toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetChrome, widget);
					    	if (toDel.length > 0) {
								widget.removeChild(toDel[0]);
					    	}
					    	toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetUserPrefs, widget);
					    	if (toDel.length > 0) {
								widget.removeChild(toDel[0]);
					    	}
					    	toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetContent, widget);
					    	if (toDel.length > 0) {
								widget.removeChild(toDel[0]);
					    	}
							break;
						case com.ibm.mm.builder.constant.iwGGadget:
							//TODO: need to double check if below tags are correct for "iw-OSGadget"
					   	 	toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetChrome, widget);
					    	if (toDel.length > 0) {
								widget.removeChild(toDel[0]);
					    	}
					    	toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetUserPrefs, widget);
					    	if (toDel.length > 0) {
								widget.removeChild(toDel[0]);
					    	}
					    	toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetContent, widget);
					    	if (toDel.length > 0) {
								widget.removeChild(toDel[0]);
					    	}
							break;																						
					}
				}catch(e){
					console.log(e);
				}
				var oneFragment = com.ibm.mm.builder.utils.htmlUtil.getElementString(widget);
				source += oneFragment;
			});  // JSLINT-IGNORE:
		}
		return source;
	},

	/**
	 * This method will set the visible of the page source window according the mode.
	 * @param {String} mode Page Source, mode=source or mode=edit
	 */
	setPageSourceMode: function(mode){
		if (mode == "source") {
		    dojo.byId('pageEdit').style.visibility = "hidden";
		    dojo.byId('pageEdit').style.display = "none";
		    dojo.byId('pageSource').style.visibility = "visible";
		    dojo.byId('pageSource').style.display = "";
		    dojo.byId('editButtons').style.visibility = "hidden";
		    dojo.byId('editButtons').style.display = "none";
		    dojo.byId('sourceButtons').style.visibility = "visible";
		    dojo.byId('sourceButtons').style.display = "";
		}else if (mode == "edit") {
			dojo.byId('pageSource').style.visibility = "hidden";
			dojo.byId('pageSource').style.display = "none";
			dojo.byId('pageEdit').style.visibility = "visible";
			dojo.byId('pageEdit').style.display = "";
			dojo.byId('sourceButtons').style.visibility = "hidden";
			dojo.byId('sourceButtons').style.display = "none";
			dojo.byId('editButtons').style.visibility = "visible";
			dojo.byId('editButtons').style.display = "";
		}
    },
	
	// since the new dialog is transparent, we need to set a white background of the dijit editor
    setEditModeBgColor: function(){
        var pageEditDiv = dojo.byId("pageEdit");
        var iframes = pageEditDiv.getElementsByTagName("IFRAME");
        if (iframes.length > 0) {
            iframes[0].style.backgroundColor = "white";
        }
    },
	
	// unescape the < >	
	unescape: function(str){
		str = str.replace(/&lt;/g, "<");
		str = str.replace(/&gt;/g, ">");
		str = str.replace(/&quot;/g, "\"");
		return str;
    }
});

}
