if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl");
dojo.require("com.ibm.mm.catalog.opensearch.ResultParser");
dojo.require("dojox.xml.parser");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil");

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget", [dijit._Widget, dijit._Templated], {
	templatePath : dojo.moduleUrl("com.ibm.mm.builder", "iwidget/spacemanager/widget/templates/PageCreationWidget.html"),
	
	widgetsInTemplate: true,
	
	parentPageId : null,
	
	spaceId : null,
	
	pageCopySpaceId : null,
	
	hideThemeSelector: false,
	copyFromAllSpaces: false,
	isFromSpaceMgr: true,
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.resourceMessage = com.ibm.mm.builder.coreWidgetsMessages;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		this._spacesLoaded = false;
		this._spacePagesLoaded = false;
		this._catalogPagesLoaded = false;
		this.cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		
		com.ibm.mashups.services.ServiceManager.getService(
			com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME)
			.subscribeEvent("com.ibm.mashups.builder.displayInMashupDialog", this, "_onDialogDisplay");
	},
	
	postMixInProperties : function() {
		var _idPrefix = "sm_createPage";
		this.idPrefix = dijit.getUniqueId(_idPrefix);
		dojo.mixin(this, this._bundle);
	},
	
	postCreate : function() {
	
		// hideThemeSelector is an option widget attribute that will hide theme selection on this dialog
		// this is most appropriate for custom themes that desire the space's theme to be used on all pages		
		var value = this.icontext.getiWidgetAttributes().getItemValue("hideThemeSelector");
		if (value) {
			this.hideThemeSelector = (value == "true");
		}

		// Force copy from spaces to false if the target is not a space.  This provides a more
		// appropriate behavior for the My Mashups use cases
		if (this.spaceId === null) {
        	this.copyFromAllSpaces = true;
        } else {
        	this.copyFromAllSpaces = false;
        }
	
		if (this.hideThemeSelector) {
			dojo.style(this._themeChooserNode, "display", "none");
		}
		
		this._themesListControl = new com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl({
			widgetId: this.widgetId
		}, this._themesContainerNode);
		dijit.setWaiState(this._themesListControl.domNode, "labelledby", this.idPrefix +"_choose_theme_label");
		
		this.connect(this._byEmptyNode, "onclick", this._byEmptyRadioClicked);
		this.connect(this._byDuplicatingNode, "onclick", this._byDuplicatingRadioClicked);
		this.connect(this._fromCatalogRadioNode, "onclick", this._fromCatalogRadioClicked);
		
		if(!com.ibm.mm.builder.commonActions.hasHub()){
			dojo.style(this._addPageFromCatalog,"display","none");
		}else{
			dojo.style(this._addPageFromCatalog,"display","block");
		}
		
		this.saveButton = dojo.query(".common_save", this.domNode)[0];
	},
	
	_onDialogDisplay: function() {
		this.saveButton.removeAttribute("disabled");
	},
	
	hide : function() {
		com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME).broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.widgetId);
	},
	
	ok : function() {
		if (this.onOk) {
			this.onOk();
		}
	},
	
	onOk : function() {
		if (this.createPage()) {
			dojo.attr(this.saveButton,"disabled","true");
			this.hide();
		}
	},
	
	onEnter: function(event) {
		if(event.keyCode==13) {
			if(!dojo.attr(this.saveButton,"disabled")) {
 				this.ok();
			}
		}
	},
	
	showMessage : function(msg, type) {
		if (msg) {
			if(!this._messageControl){
				this._messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
				messageType: 'error'}, this._messageBoxNode);
			}
			this._messageControl.attr({
				message : msg,
				messageType : type || "error"
			});
			this._messageControl.show();
		}
	},
	
	_hideMessage : function() {
		if(this._messageControl){
			this._messageControl.hide();
		}
	},
	
	_byEmptyRadioClicked : function() {
		this._disableDuplicatingAndCatalog();
	},
	
	_disableDuplicatingAndCatalog : function() {
		if (this._spacesListSelect) {
			dojo.attr(this._spacesListSelect, "disabled", "disabled");
		}
		if (this._spacePagesListSelect) {
			dojo.attr(this._spacePagesListSelect, "disabled", "disabled");
		}
		if (this._catalogPagesListSelect) {
			dojo.attr(this._catalogPagesListSelect, "disabled", "disabled");
		}
	},
	
	_byDuplicatingRadioClicked : function() {
		if (!this.spaceId) {
			return;
		}
		if (this._spacePagesLoaded) {
			if (this._spacesListSelect) {
				dojo.removeAttr(this._spacesListSelect, "disabled");
			}
			if (this._spacePagesListSelect) {
				dojo.removeAttr(this._spacePagesListSelect, "disabled");
			}
		}
		else {
			this._refreshSpaces();
		}
		if (this._catalogPagesListSelect) {
			dojo.attr(this._catalogPagesListSelect, "disabled", "disabled");
		}
	},
	
	_fromCatalogRadioClicked : function() {
		if (this._spacesListSelect) {
			dojo.attr(this._spacesListSelect, "disabled", "disabled");
		}
		if (this._spacePagesListSelect) {
			dojo.attr(this._spacePagesListSelect, "disabled", "disabled");
		}
		if (this._catalogPagesLoaded) {
			if (this._catalogPagesListSelect) {
				dojo.removeAttr(this._catalogPagesListSelect, "disabled");
			}
		}
		else {
			this._loadPagesFromCatalog();
		}
	},
	
	_refreshSpaces: function() {
		this._spacesListNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._doRefreshSpaces));
	},
	
	_doRefreshSpaces: function() {
		// reset the ID of the space containing the source page
		this.pageCopySpaceId = this.spaceId;
		
		dojo.style(this._pageSelectorNodes,"display","block");
		var spaceModel = this.spaceUtil.getSpaceModel();
		var space = spaceModel.find(this.pageCopySpaceId).start();
		var navModel = this.navigationUtil.getNavigationModel();
		var rootNodeId = space.getRootNavigation().getID();
		this._spacesListNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		var select = dojo.create("select", {"class":"space_list"});
		dojo.attr(select, "aria-labelledby", this.idPrefix + "_space_byDuplicating_label" );
		this._loadSpaces(navModel, this.enablerUtil, rootNodeId, select, 0);
		this._spacesListNode.innerHTML = "";
		this._spacesListNode.appendChild(select);
		this._spacesListSelect = select;
		this.connect(this._spacesListSelect, "onchange", this._spaceSelected);
		this._spacesLoaded = true;
		this._refreshPagesInSpace();
	},
	
	_loadSpaces : function(navModel, enablerUtil, pageId, select, level) {
		// Add personal space if there are pages in it
		if (com.ibm.mm.builder.commonActions.canCopySpace(0)) {
			var navModel = this.navigationUtil.getNavigationModel();
			if (navModel.hasChildren(navModel.getRoot().start())) {
				var nodeTitle = this._bundle.I_SPACE_PERSONAL_SPACE;
				var op = new Option(nodeTitle, 0);
				op.innerHTML = nodeTitle;
				dojo.attr(op, "title", nodeTitle);
				if (0 == this.spaceId) {
					op.selected = true;
				}		
				select.appendChild(op);
			}
		}
		// Add the other spaces
        var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
        var spaceModel = spaceUtil.getSpaceModel();
        var iter = spaceModel.iterator();
        while (iter.hasNext()) {
			var node = iter.next();
			if (com.ibm.mm.builder.commonActions.canCopySpace(node.getID())) {
				var nodeTitle = this.enablerUtil.getNodeTitle(node);
				var op = new Option(nodeTitle || this._bundle.I_SPACE_MANAGER_NO_TITLE, node.getID());
				op.innerHTML = nodeTitle || this._bundle.I_SPACE_MANAGER_NO_TITLE;
				dojo.attr(op, "title", nodeTitle || this._bundle.I_SPACE_MANAGER_NO_TITLE);
				if (node.getID() == this.spaceId) {
					op.selected = true;
				}		
				select.appendChild(op);
			}
		}
	},
	
	_spaceSelected: function() {
		this.pageCopySpaceId = this._spacesListSelect.options[this._spacesListSelect.selectedIndex].value;
		this._refreshPagesInSpace();
	},
	
	_refreshPagesInSpace : function() {
		this._spacePagesListNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._doRefreshPagesInSpace));
	},
	
	_doRefreshPagesInSpace : function() {
		var navModel = this.navigationUtil.getNavigationModel();
		if (this.pageCopySpaceId == 0) {
			var rootNodeId = navModel.getRoot().start().getID();
		} else {
			var spaceModel = this.spaceUtil.getSpaceModel();
			var space = spaceModel.find(this.pageCopySpaceId).start();
			var rootNodeId = space.getRootNavigation().getID();
		}
		this._spacePagesListNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		var select = dojo.create("select", {"class":"page_list"});
		dojo.attr(select, "aria-labelledby", this.idPrefix + "_page_byDuplicating_label" );
		this._loadPagesRecursive(navModel, this.enablerUtil, rootNodeId, select, 0);
		this._spacePagesListNode.innerHTML = "";
		this._spacePagesListNode.appendChild(select);
		this._spacePagesListSelect = select;
		this._spacePagesLoaded = true;
	},
	
	_createOptionForPage : function(title, id, level) {
		var option = dojo.create("option", {"value":id});
		var text = [];
		if (level > 0) {
			text.push("&#8970;");
		}
		for (var i = 0; i < level; i++) {
			text.push("__");
		}
		text.push(title);
		option.innerHTML = text.join("");
		return option;
	},
	
	_loadPagesRecursive : function(navModel, enablerUtil, pageId, select, level) {
		var page = navModel.find(pageId).start();
		var iterator = navModel.getChildren(page);
		while (iterator.hasNext()) {
			var p = iterator.next();
			var title = enablerUtil.getNodeTitle(p);
			var id = p.getID();
			select.appendChild(this._createOptionForPage(title, id, level));
			arguments.callee.apply(this, [navModel, enablerUtil, id, select, level + 1]);
		}
	},
	
	_getCatalogPagesSearchUrl : function() {
		var url = null;
		try {
			url = com.ibm.mm.catalog.hubUtil.getHubOpenSearchUrl();
		}
		catch (e) {
			
		}
		if (url) {
			var queryKeyword = builderConfig.pageQueryKeyword || "*",
				queryCount = builderConfig.pageQueryCount || "50";
			return this.icontext.io.rewriteURI(url + "collection=pages&searchTerms=" + queryKeyword + "&count=" + queryCount);			
        }
		return null;
	},
	
	_loadPagesFromCatalog : function() {
		this._catalogPagesListNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		var url = this._getCatalogPagesSearchUrl();
		dojo.xhrGet({
			url : url,
			handleAs : "text",
			load : dojo.hitch(this, function(data) {
				var doc = dojox.data.dom.createDocument(data);
				
				var select = dojo.create("select", {"class": "page_list"});
				var parser = com.ibm.mm.catalog.opensearch.ResultParserManager.mashuphub;
				var results = parser.parse(doc).getResults();
				for (var i = 0, n = results.length; i < n; i++) {
					if (results[i].downloadURL && !results[i].definitionURL) {
						select.appendChild(this._createOptionForPage(results[i].name, results[i].downloadURL));
					}
				}
				this._catalogPagesListNode.innerHTML = "";
				this._catalogPagesListNode.appendChild(select);
				this._catalogPagesListSelect = select;
				this._catalogPagesLoaded = true;
			}),
			error : dojo.hitch(this, function() {
				this._notifyError(this._bundle.E_SPACE_MANAGER_LIST_HUB_PAGES_FAILED);
				this._catalogPagesListNode.innerHTML = "";
			})
		});
	},
	
	_getPageNodeById : function(pid) {
		var navModel = this.navigationUtil.getNavigationModel();
		return navModel.find(pid).start();
	},
	
	createPage : function() {
		if (!this.parentPageId) {
			return;
		}
		var name = dojo.trim(this._pageNameNode.value);
		if (!name) {
			this.showMessage(this._bundle.E_SPACE_MANAGER_PAGE_NAME_REQUIRED);
			dojo.attr(this._pageNameNode, "aria-invalid", "true");
			return;
		}
		if (!this.pageUtil.validatePageName(name)) {
			this.showMessage(this._bundle.E_SPACE_MANAGER_SPACE_NAME_HAS_INVALID_CHAR_0);
			dojo.attr(this._pageNameNode, "aria-invalid", "true");
			return;
		}
		var description = dojo.trim(this._pageDescriptionNode.value);
		if (!description) description = "";
		var exceed = com.ibm.mm.builder.utils.pageUtil.isPageDescriptionLengthExceed(description);
		var errorMessage = null;
		if (exceed > 0) {
		    errorMessage = this.resourceMessage.E_PAGE_UTIL_INVALID_DESCRIPTION_LENGTH_1;
		    if (typeof(errorMessage) === 'undefined') {
		        dojo.requireLocalization("com.ibm.mm.builder", "coreWidgetsMessages", "en");
		        var enWidgetsMessages = dojo.i18n.getLocalization("com.ibm.mm.builder", "coreWidgetsMessages", "en");
		        errorMessage = enWidgetsMessages.E_PAGE_UTIL_INVALID_DESCRIPTION_LENGTH_1;
		    }
		    if (typeof(errorMessage) === 'undefined') {
		        errorMessage = "BMWMB0120E:The page description is limited to ${0} characters. Shorten your description and save again."
		    }
		    errorMessage = dojo.string.substitute(errorMessage, [exceed]);
		    this._showMessage(errorMessage);
		    dojo.attr(this._pageNameNode, "aria-invalid", "true");
		    return;
		}
		var themeId = this._themesListControl.selectedTheme;	
		
		this._hideMessage();
		var createType = dojo.query("input[name=page_create_type]", this.domNode).filter(		function(item) {
			return item.checked;
		})[0].value;
		
		switch (createType) {
			case "from_empty":
				var parentPage = this._getPageNodeById(this.parentPageId);
				return this._doCreateEmptyPage(name, description, parentPage, themeId);
			case "by_duplicating":	
				var copiedPageId = this._spacePagesListSelect.value;
				if (!copiedPageId || copiedPageId==="") {
					this.showMessage(this._bundle.E_SPACE_MANAGER_PAGE_TO_COPY_REQUIRED);
					dojo.attr(this._spacePagesListSelect, "aria-invalid", "true");
					return;
				}
				return this._doCreatePageByDuplicating(this.parentPageId, copiedPageId, name, description, themeId);
				
			case "from_catalog":
				var url = this._catalogPagesListSelect.value;
				if (!url || url==="") {
					this.showMessage(this._bundle.E_SPACE_MANAGER_PAGE_CATALOG_PAGE_REQUIRED);
					dojo.attr(this._catalogPagesListSelect, "aria-invalid", "true");
					return;
				}
				return this._createPageFromCatalog(this.parentPageId, url, name, description, themeId);
				
		}	
	},
	
	_doCreateEmptyPage : function(name, description, parentPage, themeId) {
		var navModel = this.navigationUtil.getNavigationModel();
		var newPage = navModel.create(null);
		var locale1 = builderConfig.locale;
		var locale2 = this.cs.getValue("default.locale");
		newPage.setTitle(name, locale1);
		newPage.setTitle(name, locale2);
		newPage.setDescription(description, locale1);
		newPage.setDescription(description, locale2);
		newPage.setTheme(themeId);
		navModel.insert(newPage, parentPage, null);
		
		var d = new dojo.Deferred();

		var deferred = navModel.commit();
		
		var page = null;
		deferred.setOperationCallback(dojo.hitch(this, function(node){
			page = node;
		}));
		
		deferred.setFinishedCallback(dojo.hitch(this, function(node, statusCode){
			if (newPage) {
				this._notifyToRefresh(page);
			}
		}));
		deferred.start(false);
		return d;
	},
	
	_updatedCopiedPage : function(node, parentPageId, name, description, themeId) {
		var locale1 = builderConfig.locale;
		var locale2 = this.cs.getValue("default.locale");
		var importPage = this.spaceManagerUtil.importPage;
		importPage.updateTitleAndDescription(node, name, description, locale1);
		if (locale2 != locale1) {
			importPage.updateTitleAndDescription(node, name, description, locale2);
		}
		importPage.updateParentPage(node, parentPageId);	
		importPage.updateTheme(node, themeId);	
	},
	
	_doCreatePageByDuplicating : function(parentPageId, copiedPageId, name, description, themeId) {
		var d = new dojo.Deferred();

        var copyUrl = this.spaceManagerUtil.importPage.getResourceCollectionsUrl() + "&mode=duplicate" 
											   + "&copyPageId=" + copiedPageId
											   + "&parentPageId=" + parentPageId 
											   + "&pageName=" + encodeURIComponent(name)
											   + "&description=" + encodeURIComponent(description)
											   + "&themeId=" + themeId;
								
		dojo.xhrPost({
			url : copyUrl,
			
			headers : {
				"Content-Type" : "text/xml; charset=UTF-8"
			},
			
			load : dojo.hitch(this, function(data) {
				d.callback(data);
				//parse data						
	            var newPageId = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil.util.parseResourceIdFromResponseData(data);
				var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(newPageId);
                
                // refresh parent node so that the navigation can be correctly redrawn
                var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(newPageId);
                var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
                navModel.invalidate(parentPageId);
                
				this._notifyToRefresh(newPage);
			}),
			error : dojo.hitch(this, function() {
				this._notifyError(this._bundle.E_SPACE_MANAGER_CREATE_NEW_PAGE_FAIL);
			})
		});
		return d;
	},
	
	_updateCatalogPage : function(node, parentPageId, name, description, themeId) {
		var locale1 = builderConfig.locale;
		var locale2 = this.cs.getValue("default.locale");
		var importPage = this.spaceManagerUtil.importPage;		
		importPage.updateTitleAndDescription(node, name, description, locale1);
		if (locale2 != locale1) {
			importPage.updateTitleAndDescription(node, name, description, locale2);
		}
		importPage.updateParentPage(node, parentPageId);	
		importPage.updateTheme(node, themeId);	
	},
	
    _createPageFromCatalog : function(parentPageId, downloadUrl, name, description, themeId) {
	    
		var d = new dojo.Deferred();
		var hubImportServiceUrl = downloadUrl.replace("download_page","import_page");    
		var mashupsImportServiceUrl = this.spaceManagerUtil.importPage.getResourceCollectionsUrl() + "&mode=import";
		hubImportServiceUrl = this.icontext.io.rewriteURI(hubImportServiceUrl);   
		
	        dojo.xhrPost({
	        
	            url : hubImportServiceUrl,
	            handleAs : "json",
	            
	            content : {
	                "authType": "Form",
	                "description": description,
	                "import_service_url": mashupsImportServiceUrl,
	                "title": name,
	                "locale": this.cs.getValue("default.locale"),
	                "parentId": parentPageId
	            },
	            
	            load : dojo.hitch(this, function(data) {		    
					d.callback(data);

	            	//parse data	
	            	var newPageId = data.pageId.split(":")[2];
	            	var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(newPageId);

                    // refresh parent node so that the navigation can be correctly redrawn
                    var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(newPageId);
                    var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
                    navModel.invalidate(parentPageId);

	            	this._notifyToRefresh(newPage);         
	            }),
	            
	            error : dojo.hitch(this, function() {
	            	this._notifyError(this._bundle.E_SPACE_MANAGER_CREATE_NEW_PAGE_FAIL);
	            })
	        });
		return d;
	},
	
	_notifyToRefresh : function(newPage) {
		if (newPage) {
			dojo.publish(this._constants.Topic.Space.refresh, [this._constants.Action.ADD_PAGE, {
				spaceId: this.spaceId,
				parentPageId: this.parentPageId,
				page: newPage
			}]);
		}
		else {
			dojo.publish(this._constants.Topic.Space.refresh);
		}
		
//		if (!this.isFromSpaceMgr) {
//			var pageId = newPage.getID();
//			var eventService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
//			eventService.broadcastEvent("com.ibm.mashups.builder.switchPage", pageId);
//		}
		
		if (this.spaceId == com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()) {
			com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME).broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
		}
		
	},
	
	_notifyError : function(message) {
		this.showMessage(message || "");
	},
	
	setSpaceId : function(spaceId){
		this.spaceId = spaceId;
	},
	
	setParentPageId: function(parentPageId){
		this.parentPageId = parentPageId;
	},
	
	setIsFromSpaceMgr: function (fromSpaceMgr) {
		this.isFromSpaceMgr = fromSpaceMgr;
	},
	
	cleanUI: function(){
		this._pageNameNode.value = "";
		this._pageDescriptionNode.value = "";
		this._byEmptyNode.checked = true;
		dojo.style(this._pageSelectorNodes,"display","none");
		this._spacesListNode.innerHTML = "";
		this._spacePagesListNode.innerHTML = "";
		this._catalogPagesListNode.innerHTML = "";
		this._spacePagesLoaded = false;
		this._catalogPagesLoaded = false;
		this._hideMessage();
		this._themesListControl.refresh(com.ibm.mm.builder.utils.themeUtil.getThemeId(this.parentPageId));
	}
});

}
